//***********************************************************
// Agat RT, Russia, Moscow, tel./fax +7(095)799-9069, +7(095)656-5492,
//                                   +7(095)656-5592
// http://www.agatrt.ru
// mailto:info@agatrt.ru
// 15/03/2010 Version 7.3.7.1
//**********************************************************************

// #define _X_TRACE_IT_

#ifndef ALDERSDK_H
#define ALDERSDK_H

#include <windows.h>

#ifdef COMPILE_DLL 
	#define SDKEXPORT_ extern "C" __declspec(dllexport) 
	#define SDKIMPORT_
#else
	#define SDKEXPORT_
	#define SDKIMPORT_ extern "C" __declspec(dllimport) 
	#pragma comment (lib,"AlderSDK.lib")
#endif

//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkInit();
//     
// LoadersPath	-    (    )
SDKIMPORT_ SDKEXPORT_ DWORD sdkInitEx( char *pszLoadersPath);
//  
SDKIMPORT_ SDKEXPORT_ DWORD sdkLeave();

//    
// BoardsCount	-	  
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetBoardsCount( DWORD *lpdwBoardsCount);

//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetChannelIntParams( DWORD	dwChannelId, 
												   HANDLE *lphDriver,
												   DWORD *lpdwBoardHandle,
												   DWORD *lpdwLineIndx);

//  
#define ALDER_DRV						0x00	//  Alder
#define ALDER9_DRV						0x01	//  Alder9
#define ALDER12_DRV						0x02	//  Alder12
#define ALDER12E_DRV					0x03	//  Alder12E
#define ALDER14T_DRV					0x04	//  Alder14T

//  
#define DRV_NOT_LOADED					0x00	//   		
#define DRV_LOADED						0x01	//  
#define DRV_STARTED						0x02	//   

//      AlderSDK 
typedef struct tagsdkSDKVersion
{
	DWORD	SDKMajor;
	DWORD	SDKMinor;
	DWORD	SDKInt1;
	DWORD	SDKInt2;
}sdkSDKVersion;
//   SDK
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetVersion( sdkSDKVersion *SDKVersion);

//    
// DriversCount	-	  
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetDriversCount( DWORD *lpdwDriversCount);
//   
// DriversCount -   
// DriversId -	  
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetDriversIds( DWORD dwDriversCount, DWORD *lpdwDriversId);

//      . 
typedef struct tagsdkDriverVersion
{
	DWORD	Type;
	DWORD	Major;
	DWORD	Minor;
	DWORD	Loader;
}sdkDriverVersion;
//   
// DriverId								-	 
// DriverVersion						-	 
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetDrvVersion( DWORD dwDriverId, sdkDriverVersion *lpDriverVersion);

//  
#define ALDER_24A_BOARD					0x01	// 24
#define ALDER_24AM_BOARD				0x02	// 24
#define ALDER_22A_BOARD					0x03	// 22
#define ALDER_21A_BOARD					0x20	// 21
#define ALDER_616_BOARD					0x40	// 6 
#define ALDER_716_BOARD					0x60	// 7
#define ALDER_ISDN_BOARD				0xC0	// 2-ISDN
#define ALDER9_BOARD					0x81	// 9
#define ALDER10_BOARD					0x82	// 10
#define ALDER10LP_BOARD					0x85	// 10-lp	
#define ALDER10LPS_BOARD				0x86	// 10-lps
#define ALDER10LPO_BOARD				0x87	// 10-lpo
#define ALDER10_ISDN_BOARD				0xC5	// 10-ISDN (C5)
#define ALDER9_ISDN_BOARD				0xC7	// 9-ISDN (C7)
#define ALDER12_USB_DEVICE				0x41	// 12-USB 
#define ALDER12_ETH_DEVICE				0x31
#define ALDER12_ETHM_DEVICE				0x32	
#define ALDER14T_BOARD					0xA1
#define ALDER14LPX_BOARD				0xA5
#define ALDER14LPE_BOARD				0xA6

//   
#define ISA_BUS							0x00	//  ISA
#define PCI_BUS							0x02	//  PCI
#define USB_DEVICE						0x03	// USB 
#define ETH_DEVICE						0x04	// ETH 

//   
#define BOARD_CLOSED					0x00	//  
#define BOARD_OPENED					0x01	//  
#define BOARD_REMOVED					0x02	//  

//   
typedef struct tagsdkBoardStatus
{
	DWORD	BoardId;							//  
	DWORD	OwnDriverId;						//   
	DWORD	Type;								//  
	DWORD	Bus;								//   
	DWORD	Status;								//  
	DWORD	BasePort;							//   
	DWORD	FactoryNumber;						//  
	DWORD	FactoryVersion;						//  
	DWORD	ResourceMode;						//  
	DWORD	Lines;								//   
	DWORD	VoiceLines;						    //   
	DWORD	ChannelsId[128];					//  
	BYTE	LineTypes[128];						//   
	BYTE	PossibleLineTypes[128];				//    	
	BYTE	LineStatus[128];					//   
	DWORD	Cpus;								//  						
	BYTE	E1Present;							//     1
	DWORD 	PciCtrlPort;
	BOOL	SCBus;
	BOOL	SCBusMaster;
	BOOL	IrqMaster;
	DWORD	E1Lines;
	DWORD	E1MajorVersion;
	DWORD	E1MinorVersion;
	DWORD	E1STS;
}sdkBoardStatus;		
//    
// BoardId								-    
// BoardIndx							-	  (  ,  -1)
// BoardStatus							-	 
SDKIMPORT_ SDKEXPORT_ DWORD sdkUpdateBoardStatus( DWORD dwBoardId, int iBoardIndx, sdkBoardStatus *lpBoardStatus);

//    
// BoardId								-    
// Loader								-	 
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetBoardLoader( DWORD dwBoardId, char *pszLoader);
//    ISDN - 
// BoardId								-    
// Loader								-	 
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetBoardLoader( DWORD dwBoardID, char *pszLoader);

//    imp-  ISDN - 
// BoardId								-    
// pszFile								-	imp-
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetBoardImpParams( DWORD dwBoardId, char *pszFile);

//       
// BoardsCount	-     
// BoardStatus	-	   
SDKIMPORT_ SDKEXPORT_ DWORD sdkUpdateBoards( DWORD dwBoardsCount, sdkBoardStatus *lpBoardStatus[]);

//       ( Delphi)
// Ptr	-	  
// Size	-     ( BoardsCount*sizeof(sdkBoardStatus) !!!)
//  				-	 
SDKIMPORT_ SDKEXPORT_ DWORD sdkCopyBoardsStatus( void *lpPtr, int iSize);


// ======================================================================
// ===============     1 ===============
// ======================================================================
//    E1
#define sdkE1R15STS						0x10
#define sdkE1R2STS						0x20
#define sdkE1EDSS1STS					0x30
#define sdkE1QSIGSTS					0x40
#define sdkE1V5STS						0x50
#define sdkE1OKS7STS					0x70

//   Type
#define sdkE1EDSS1Terminal				0x01	//  .   EDSS1.
#define sdkE1EDSS1Monitor				0x02	//  .   EDSS1.
#define sdkE1R2Terminal					0x03	//  .   R 2.
#define sdkE1R2Monitor					0x04	//  .   R 2.
#define sdkE1R15Terminal				0x05	//  .   R 1,5.
#define sdkE1R15Monitor					0x06	//  .   R 1,5.
#define sdkE1TestMonitor				0x07	//     1    .
//        1.
typedef struct tagsdkE1STSParams
{
	DWORD	BoardId;							//  
	DWORD	E1Device;							//    
	DWORD	E1PhisicalLine;						//   1 (0,1)
	DWORD	Type;								//    1.
}sdkE1STSParams;
//     1
// E1STSParams -        1.
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1STS( sdkE1STSParams E1STSParams);

//   SynchroType
#define sdkE1SynchroDoubleFrame			0x00	// (CRC4)Double Frame - ,    .   .
#define sdkE1SynchroMultiFrame			0x01	// ( NOCRC4)Multi Frame - ,    . 
//       .
typedef struct tagsdkE1SynchroParams
{
	DWORD	BoardId;							//  
	DWORD	E1Device;							//    
	DWORD	E1PhisicalLine;						//   1 (0,1)
	DWORD	SynchroType;						//  
}sdkE1SynchroParams;
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1SynchroType( sdkE1SynchroParams E1SynchroParams);
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1SynchroType( sdkE1SynchroParams *lpE1SynchroParams);

//   Mode
#define sdkE1VoiceSynchroByBoard		0x00	//   - .   .
#define sdkE1VoiceSynchroByStream		0x01	//   -    1.
//       -.
typedef struct tagsdkE1VoiceSynchroParams
{
	DWORD	BoardId;							//  
	DWORD	E1Device;							//    
	DWORD	E1PhisicalLine;						//   1 (0,1)
	DWORD	Mode;								//   
}sdkE1VoiceSynchroParams;
//     - 
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1VoiceSynchro( sdkE1VoiceSynchroParams E1VoiceSynchroParams);
//     - 
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1VoiceSynchro( sdkE1VoiceSynchroParams *lpE1VoiceSynchroParams);

//   CodeType
#define sdkE1LinearCodeHDB3				0x00	// HDB 3 (High Density Bipolar-3).   .
#define sdkE1LinearCodeAMI				0x01	// AMI (Alternate Mark Inversion).
//       
typedef struct tagsdkE1LinearCodeParams
{
	DWORD	BoardId;							//  
	DWORD	E1Device;							//    
	DWORD	E1PhisicalLine;						//   1 (0,1)
	DWORD	CodeType;							//   
}sdkE1LinearCodeParams;
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1LinearCode( sdkE1LinearCodeParams E1LinearCodeParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1LinearCode( sdkE1LinearCodeParams *lpE1LinearCodeParams);

//   ConnectionType
#define sdkE1UserUserConnection			0x00	//   User - User.   .
#define sdkE1NetUserConnection			0x01	//   Net - User.
#define sdkE1UserNetConnection			0x02	//   User - Net.
#define sdkE1NetNetConnection			0x03	//   Net - Net.
//       .
typedef struct tagsdkE1ConnectionTypeParams
{
	DWORD	BoardId;							//  
	DWORD	E1Device;							//    
	DWORD	E1PhisicalLine;						//   1 (0,1)
	DWORD	ConnectionType;						//  
}sdkE1ConnectionTypeParams;
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1ConnectionType( sdkE1ConnectionTypeParams E1ConnectionTypeParams);
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1ConnectionType( sdkE1ConnectionTypeParams *lpE1ConnectionTypeParams);

//   DTEMode
#define sdkE1DTESlave					0x00	//   1   Slave.   .
#define sdkE1DTEMaster					0x01	//   1   Master.
//       D-   EDSS-1
typedef struct tagsdkE1DTEModeParams
{
	DWORD	BoardId;							//  
	DWORD	E1Device;							//    
	DWORD	E1PhisicalLine;						//   1 (0,1)
	DWORD	DTEMode;							//   D-
}sdkE1DTEModeParams;
//      D-   EDSS-1
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1DTEMode( sdkE1DTEModeParams E1DTEModeParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1DTEMode( sdkE1DTEModeParams *lpE1DTEModeParams);

//   E1DeviceType
#define sdkE1AtticE1Terminal60			0x84	//        1.
#define sdkE1AtticE1Terminal30			0x86	//        1.
#define sdkE1AtticE1Monitor30			0x87	//        1.    () .
//    E1
typedef struct tagsdkE1HardwareProperties
{
	DWORD	BoardId;							//  
	DWORD	E1DeviceAmount;						//    .
	DWORD	E1DeviceType[2];					//    .
	DWORD	E1LinesAmount[2];					//   1,      
}sdkE1HardwareProperties;
//       1 
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1HardwareProperties( sdkE1HardwareProperties *lpE1HardwareProperties);


//   Changed
#define sdkE1RawDataReady				0x01	//         (   ).
#define sdkE1SynchroInfo				0x02	//    .
#define sdkE1DstateInfo					0x04	//   D-.
//   SynchroInfo
#define sdkE1SynchroEstablished			0x00	//  .
#define sdkE1CarrierLost				0x01	//    (   ).
#define sdkE1AIS						0x02	//   .
#define sdkE1LosOfSync					0x03	//   .
#define sdkE1RemoteAlarm				0x04	//      .
#define sdkE1Sleep						0x07	//  .
//   DStateInfo
#define sdkE1DStateAwaitEstablish		0x00	//   D- .
#define sdkE1DStateMultiFrame			0x01	//   D-         .
#define sdkE1DStateIsReady				0x01	//   D-         .
#define sdkE1DStateTimerRecovery		0x02	//            D-.
#define sdkE1DStateNothing				0x03	//        .
#define sdkE1DStateError				0x04	//      D-.
//    1
typedef struct tagsdkE1Status
{
	DWORD	BoardId;							//  
	DWORD	E1Device;							//    
	DWORD	Changed;							//   0,      1
	DWORD	SynchroInfo[2];						//   
	DWORD	DStateInfo[2];						//  D-
	DWORD	DataReadyAmount;					//  ,    (   ).
}sdkE1Status;
//    1
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1Status( sdkE1Status *lpE1Status);

//    E1   
// BoardId		-	 
// Mode			-	 
//					0		-	     .
//					 0	-	    1 ( ).	
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1RawMode( DWORD dwBoardId, DWORD dwMode);
//      E1
// BoardId		-	 
// Mode			-		
//					0		-	     .
//					 0	-	    1 ( ).	
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1RawMode( DWORD dwBoardId, DWORD *Mode);

//          E1
typedef struct tagsdkE1RawDataParams
{
	DWORD	BoardId;							//  
	DWORD	E1Device;							//    
	void	*RawData;							//      .
	DWORD	DwLen;								//   .
}sdkE1RawDataParams;
//      1
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1RawData( sdkE1RawDataParams *lpE1RawDataParams);
//      1
SDKIMPORT_ SDKEXPORT_ DWORD sdkPutE1RawData( sdkE1RawDataParams E1RawDataParams);


//   Mode
#define sdkE1TonalGeneratorDTMF			0x00	//   DTMF-.
#define sdkE1TonalGeneratorMFC1			0x01	//     MFC1. ( R2).
#define sdkE1TonaGeneratorMFC2			0x02	//     MFC2. ( R2).
#define sdkE1TonalGeneratorMFS			0x03	//     MFS. ( R1.5).
#define sdkE1TonalGeneratorAON			0x04	//    .
//      .
typedef struct tagsdkE1ToneGeneratorParams
{
	DWORD	Mode;								//   . 
	DWORD	Duration;							//   .
	DWORD	Pause;								//     . 
	char	Num[16];							//   -    .
}sdkE1ToneGeneratorParams;

//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1ToneGenerator( DWORD dwChannelId, sdkE1ToneGeneratorParams E1ToneGeneratorParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1ToneGenerator( DWORD dwChannelId, sdkE1ToneGeneratorParams *lpE1ToneGeneratorParams);

//   Mode
#define sdkE1TonalDetectorOff			0x01	//    .   .
#define sdkE1TonalDetectorDTMF			0x03	//   DTMF-.
#define sdkE1TonalDetectorMFC1			0x04	//     MFC1. ( R2).
#define sdkE1TonalDetectorMFC2			0x05	//     MFC2. ( R2).
#define sdkE1TonalDetectorMFS			0x06	//     MFS. ( R1.5).
#define sdkE1TonalDetectorAON			0x07	//    .
//      .
typedef struct tagsdkE1ToneDetectorParams
{
	DWORD	Mode;								//   .	
	DWORD	Reserved;							// 
}sdkE1ToneDetectorParams;

//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1ToneDetector( DWORD dwChannelId, sdkE1ToneDetectorParams E1ToneDetectorParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1ToneDetector( DWORD dwChannelId, sdkE1ToneDetectorParams *lpE1ToneDetectorParams);

//   Type
#define sdkE1LineUniversal				0x00	//  .       ,    .
#define sdkE1LineIncoming				0x01	//  .    .
#define sdkE1LineOutgoing				0x02	//  .    .
//       1.
typedef struct tagsdkE1LineTypeParams 
{
	DWORD	Type;								//  .
	DWORD	Reserved;							// 
}sdkE1LineTypeParams;

//     EDSS-1 
SDKIMPORT_ SDKEXPORT_ DWORD sdkE1SetLineType( DWORD dwChannelId, sdkE1LineTypeParams E1LineTypeParams);
//     EDSS-1 
SDKIMPORT_ SDKEXPORT_ DWORD sdkE1GetLineType( DWORD dwChannelId, sdkE1LineTypeParams *lpE1LineTypeParams);

//   Type
#define sdkE1DialModeEnBlock			0x00	
#define sdkE1DialModeOverlap			0x01	
//      .
typedef struct tagsdkE1DialModeParams 
{
	DWORD	BoardId;
	DWORD	E1Device;							// 
	DWORD	E1PhisicalLine;						// 
	DWORD	DialMode;							//   	
	DWORD	Reserved;							// 
}sdkE1DialModeParams;

//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1DialMode( sdkE1DialModeParams E1DialModeParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1DialMode( sdkE1DialModeParams *lpE1DialModeParams);

//    -  .
typedef struct tagsdkE1OverlapTimeOutParams
{
	DWORD	BoardId;
	DWORD	E1Device;							// 
	DWORD	E1PhisicalLine;						// 
	DWORD	TimeOut;							// -  
	DWORD	Reserved;							// 
}sdkE1OverlapTimeOutParams;

//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1OverlapTimeOutParams( sdkE1OverlapTimeOutParams E1OverlapTimeOutParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1OverlapTimeOutParams( sdkE1OverlapTimeOutParams *lpE1OverlapTimeOutParams);

//      .
typedef struct tagsdkE1DigitsNumberParams
{
	DWORD	BoardId;
	DWORD	E1Device;							// 
	DWORD	E1PhisicalLine;						// 
	DWORD	Digits;								//  
	DWORD	Reserved;							// 
}sdkE1DigitsNumberParams;
//    ()  (CalledNumber)
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1CalledNumberParams( sdkE1DigitsNumberParams E1DigitsNumberParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1CalledNumberParams( sdkE1DigitsNumberParams *lpE1DigitsNumberParams);
//    (,  )  (CallerNumber)
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1CallerNumberParams( sdkE1DigitsNumberParams E1DigitsNumberParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1CallerNumberParams( sdkE1DigitsNumberParams *lpE1DigitsNumberParams);

#define sdkE1MFREnable			0x1
#define sdkE1DecadeEnable		0x0
//    MFR.
typedef struct tagsdkE1MFRParams
{
	DWORD	BoardId;
	DWORD	E1Device;							// 
	DWORD	E1PhisicalLine;						// 
	DWORD	Enable;								// 
	DWORD	ToneDuration;						// 
	DWORD	PauseDuration;						// 
	DWORD	Reserved;							// 
}sdkE1MFRParams;

//   Mfr
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1MFRParams( sdkE1MFRParams E1MFRParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1MFRParams( sdkE1MFRParams *lpE1MFRParams);

//    E1
typedef struct tagsdkE1MonitorSetParams
{
	DWORD	BoardId;
	DWORD	E1Device;
	DWORD	E1Line;
	DWORD   Mode;
}sdkE1MonitorSetParams;
//    E1
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1MonitorMode( sdkE1MonitorSetParams *lpE1MonitorSetParams);
//    E1
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1MonitorMode( sdkE1MonitorSetParams E1MonitorSetParams);

//    E1
typedef struct tagsdkE1MonitorGetParams
{
	DWORD	BoardId;
	DWORD	E1Device;
	WORD	MonBuf[4096];
	DWORD	Readed;			//  
	DWORD	Reserved;
}sdkE1MonitorGetParams;

//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1MonitorData( sdkE1MonitorGetParams *lpE1MonitorGetParams);

typedef struct _tagsdkEDSS1Params
{
	DWORD dwBoardID;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwLinearCode;				// 0 - HDB3, 1 - AMI
	DWORD dwSynchroType;			// 0 - CRC4, 1 - NOCRC4
	DWORD dwDTEMode;				// 0 - Slave, 1 - Master
	DWORD dwCallingNumberType;		// (#)0 - *Unknown, 1 - International, 2 - National, 3 - Network, 4 - Subscriber, 6 - Abbreviated
	DWORD dwCallingScreenIndicator;	// (#)0 - *NScreened, 1 - VerifyPass, 2 - VerifyFail, 3 - Network
	DWORD dwCallingPresentIndicator;// (#)0 - Allowed, 1 - *Restricted, 2 - NotAviable
	DWORD dwCalledNumberType;		// (#)0 - *Unknown, 1 - International, 2 - National, 3 - Network, 4 - Subscriber, 6 - Abbreviated
	DWORD dwT302Time;				// (#)1 - 59 (15- by default)
	DWORD lpdwReserved[21];			// Reserved
} sdkEDSS1Params;
// (#) - only for Alder-14 boards series
// (%) - only for Alder-9 boards series

SDKIMPORT_ SDKEXPORT_ DWORD sdkSetEDSS1Params( sdkEDSS1Params EDSS1Params);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetEDSS1Params( sdkEDSS1Params *lpEDSS1Params);

typedef struct _tagsdkSS7Params
{
	DWORD dwBoardID;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwLinearCode;		// 0 - HDB3, 1 - AMI
	DWORD dwSynchroType;	// 0 - CRC4, 1 - NOCRC4
	DWORD dwOPC;			// Originator Point code ( 1 - by default, 0-99999)
	DWORD dwDPC;			// Destination Point code ( 2 - by default, 0-99999)
	DWORD dwNetType;		// Network Indicator ( 2 - by default, 0-3)
	DWORD dwLink;			// Signaling link code ( 0 - by default, 0-15)
	DWORD dwHighCIC;		// High bits of Circuit Identification code ( 0 - by default, 0-127)
	DWORD dwKindPrior;		// (#) ( 1- by default, 0-4)
	DWORD dwDefCategory;	// (#) Calling party's category ( 10-by default, 0-254)
	DWORD dwMediaRequest;	// (#) ( 3- by default, 0-99)
	DWORD dwForwardInd;		// (#) Forward call indicators ( 96-by default, 0-9999)
	DWORD dwBackwardInd;	// (#) Backward call indicators ( 1040-by default, 0-9999)
	DWORD dwSubscrAddrPlan;	// (#) Numbering plan indicator ( 1-by default, 0-9)
	DWORD dwSubscrAddrINN;	// (#)Internal Network number indicator ( 0-by default, 0-9)
	DWORD dwSubscrAddrAPRI;	// (#)Address presentation restricted indicator ( 0-by default, 0-9)
	DWORD dwSubscrAddrScreen; // (#)Screening indicator ( 1-by default, 0-9)
	DWORD dwLocationValue;	// (%) 0..15 ( 0 by default)
	DWORD dwDTEMode;		// (%) 0 - Slave, 1 - Master
	DWORD lpdwReserverd[108];
} sdkSS7Params;
// (#) - only for Alder-14 boards series
// (%) - only for Alder-9 boards series
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetSS7Params( sdkSS7Params EDSS1Params);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetSS7Params( sdkSS7Params *lpEDSS1Params);

typedef struct _tag_sdkE1Properties
{
	DWORD dwBoardID;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwManualAlerting;		// != 0 Driver do not sent ALERTING automatically
	DWORD dwQ931Monitoring;		//(#) != 0 device sent to driver monitor device Q931 receipt
	DWORD dwQ921Monitoring;		//(#) != 0 device sent to driver monitor device Q921 receipt
	DWORD lpdwReserved[58];
} sdkE1Properties;
// (#) only for Alder14 board
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1Properties( sdkE1Properties Properties);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetE1Properties( sdkE1Properties *lpProperties);

SDKIMPORT_ SDKEXPORT_ DWORD sdkE1Alerting( int iChannelID);

//  
#define FULLPHONE_CHANNEL				0x00	//    .
#define ACCU_CHANNEL					0x01	//  .
#define SAFEPHONE_CHANNEL				0x02	//    
#define ABONENTPHONE_CHANNEL			0x03	//  .
#define E1_CHANNEL						0x04	//  1
#define E1_MONITORING_CHANNEL			0x05	//  1  
#define ISDN_MONITORING_CHANNEL			0x06	//  ISDN   *   C7

//  
#define CHANNEL_FREE					0x00	//  
#define CHANNEL_BUSY					0x01	//    
#define CHANNEL_RESERVED				0x02	//  
#define CHANNEL_OPENED					0x03	//  

//   
typedef struct tagsdkLineStatus
{
	DWORD	Changed;						//    
	DWORD	Status;							//   
	DWORD	Level;							//  
	DWORD	RecDeltaBuf;						//   
	DWORD	PlayDeltaBuf;						//   
	DWORD	RawDeltaBuf;						//      
	DWORD	VoxCount;						//   VOX
	char	IncommingNum[32];					//  , ()
	char	IncommingQlt[16];					//   -
	char	E1UserId[32];						//   (  E1)
	char	Pulse[128];						//    
	char	Tone[128];						//    
	char	LastPulseNum;						//    
	BYTE	Reserved1;						// 
	char	LastToneNum;						//    
	BYTE	Reserved2;						// 
}sdkLineStatus;		
//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetLineStatus( DWORD dwChannelId, sdkLineStatus *lpLineStatus);


//   Changed
#define sdkLineHook           	0x00000001
#define sdkLineAccu           	0x00000002
#define sdkLineLevel          	0x00000004
#define sdkLineRing				0x00000008
#define sdkLineOutgoing			0x00000010
#define sdkLineIncoming			0x00000020
#define sdkLineNoDialTone		0x00000040
#define sdkLineDialTone			0x00000080
#define sdkLineBackRing			0x00000100
#define sdkLineBusy				0x00000200
#define sdkLineDefined			0x00000400	
#define sdkLineCallerID			0x00000400	//    E1
#define sdkLinePulseNum			0x00000800
#define sdkLineCalledID			0x00000800	//    E1
#define sdkLineToneNum			0x00001000
#define sdkLineNumDialed		0x00002000
#define sdkLineRecord			0x00004000
#define sdkLinePlayed			0x00008000
#define sdkLineInNumFault		0x00010000
#define sdkLineInVox			0x00020000
#define sdkLineLastPulseNum 	0x00040000
#define sdkLineVAD				0x00080000
#define sdkLineToneNumDialed	0x00100000
#define sdkLineFAX				0x00200000
#define sdkLineConnect			0x00400000
#define sdkLineRawRecord		0x00400000	//     -2 
#define sdkLineFlash			0x00800000
#define sdkLineLocked			0x01000000
#define sdkLineNoSynchro		0x02000000	//    E1
#define sdkLineEndPlay			0x04000000	
#define sdkLinePolarity			0x08000000
#define sdkLineRelease			0x10000000	//    E1
#define sdkLineBreak			0x20000000	//    
#define sdkLineTSReady			0x40000000	//    E1
#define sdkBoardError			0x80000000

//       
typedef struct tagsdkLineTypeParams
{
	DWORD	Type;								//  
	DWORD	Reserved;							// 
}sdkLineTypeParams;

//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetLineType( DWORD dwChannelId, sdkLineTypeParams LineTypeParams);
//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetLineType( DWORD dwChannelId, sdkLineTypeParams *lpLineTypeParams);

// -----    -----
//      
typedef struct tagsdkPhoneParams
{
	DWORD	HookLevel;							//    
	DWORD	RingLevel;							//   
}sdkPhoneParams;
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetLineParams( DWORD dwChannelId, sdkPhoneParams PhoneParams);
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetLineParams( DWORD dwChannelId, sdkPhoneParams *lpPhoneParams);

// -----  -----
//    
typedef struct tagsdkEchoParams
{
	DWORD	EchoMode;							//   
	DWORD	RestEchoMode;						//    
	//DWORD	Reserved;							// 
}sdkEchoParams;
//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetEcho( DWORD dwChannelId, sdkEchoParams EchoParams);
//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetEcho( DWORD dwChannelId, sdkEchoParams *lpEchoParams);

typedef struct _tag_sdkEchoParamsEx
{
	DWORD	dwEchoMode;
	DWORD	dwRestEchoMode;
	DWORD	dwNlpSensLevel;	//     (0,96dB,  1dB, 9dB  )
	int		iNoiseVolume;	//  ,      (-96,96 dB,  1 dB, -45 dB  )
	DWORD	dwNoiseType;	//  ,      (0 - , 1 -  , 2 -   )
	DWORD	lpdwReserved[59];
} sdkEchoParamsEx;
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetEchoEx( DWORD dwChannelId, sdkEchoParamsEx EchoParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetEchoEx( DWORD dwChannelId, sdkEchoParamsEx *lpEchoParams);

// -----  ----- 
//    
typedef struct tagsdkAonParams
{
	DWORD	Mode;								//   -
	DWORD	Level;								//    
	DWORD	Delay;								//        
	DWORD	Duration;							//    
	DWORD	Request;							//   
}sdkAonParams;
//   AO
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetAon( DWORD dwChannelId, sdkAonParams AonParams);
//   AO
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetAon( DWORD dwChannelId, sdkAonParams *lpAonParams);

// -----    ----- 
//      
typedef struct tagsdkNumDialRecordParams
{
	DWORD	Mode;								// 
	DWORD	Reserved;							// 
}sdkNumDialRecordParams;
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetNumDialRecord( DWORD dwChannelId, sdkNumDialRecordParams NumDialRecordParams);
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetNumDialRecord( DWORD dwChannelId, sdkNumDialRecordParams *lpNumDialRecordParams);

// -----   VAD ----- 
//    VAD
typedef struct tagsdkVadParams
{
	DWORD	Level;								//    
	DWORD	Reserved;							// 
}sdkVadParams;
//    VAD
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetVadLevel( DWORD dwChannelId, sdkVadParams VadParams);
//    VAD
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetVadLevel( DWORD dwChannelId, sdkVadParams *lpVadParams);

// ----      ----
//    / 
typedef struct tagsdkHookParams
{
	DWORD	Mode;								//  (1- ,0- )
	DWORD	dwReleaseCause;						//    Q.931   1
}sdkHookParams;
// /   
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetHookMode( DWORD dwChannelId, sdkHookParams HookParams);

//     
typedef struct tagsdkDialParams
{
	DWORD	Mode;								//   (1-, 0-)
	char	*Number;							// 
	char	*CalledID;							//   
	DWORD	HardwareType;						//  .
}sdkDialParams;
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkDialNumber( DWORD dwChannelId, sdkDialParams DialParams);

//     Connect
typedef struct tagsdkConnectParams
{
	DWORD	Mode;								//   (0,1,2)
	DWORD	Reserved;							// 
}sdkConnectParams;
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetConnectMode( DWORD dwChannelId, sdkConnectParams ConnectParams);

//     
typedef struct tagsdkGenerateToneParams
{
	DWORD	Frequency;							//   (0,300-3400)
	DWORD	Reserved;							// 
}sdkGenerateToneParams;
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkLineGenTone( DWORD dwChannelId, sdkGenerateToneParams GenerateToneParams);

//      
typedef struct tagsdkPBXToneParams
{
	DWORD	PBXTone;							//  
	DWORD	PBXToneFreq;						//     
	DWORD	Reserved;
}sdkPBXToneParams;
//    DIALTONE, RINGBACK, BUSY  
SDKIMPORT_ SDKEXPORT_ DWORD sdkLineGenPBXTone( DWORD dwChannelId, sdkPBXToneParams PBXToneParams);

//       
typedef struct tagsdkRingParams
{
	DWORD	Mode;								// 
	DWORD	Reserved;							// 
}sdkRingParams;
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkLineToRing( DWORD dwChannelId, sdkRingParams Params);

//        c     CallerID
#define sdkCallerIDSMDFType		1	// Simple mode transfer data packet
#define sdkCallerIDMDMFType		2   // Extended mode transfer data packet
#define sdkCallerIDOutOfArea	1	
#define sdkCallerIDPrivateInfo	2	
typedef struct _tag_sdkRingParamsEx
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	// CallerID info for FXS lines
	DWORD	dwCallerIDMode;			// _CallerID_SMDF_Type_ or _CallerID_MDMF_Type_
	char	lpbMonth[2];			// ASCII digits
	char	lpbDay[2];				// ASCII digits
	char	lpbHours[2];			// ASCII digits
	char	lpbMinuts[2];			// ASCII digits
	char	pszNumber[32];			// ASCII digits, ASCIIZ stirng
	DWORD	dwNumberAbsentCause;	// _CallerID_OutOfArea_ or _CallerID_PrivateInfo_
	char	pszUserName[16];		// ASCII digits, ASCIIZ stirng
	DWORD	dwUserNameAbsentCause;	// _CallerID_OutOfArea_ or _CallerID_PrivateInfo_
	DWORD   lpdwReserved[44];
} sdkRingParamsEx;
SDKIMPORT_ SDKEXPORT_ DWORD sdkLineToRingEx( DWORD dwChannelId, sdkRingParamsEx Params);

//    
typedef struct tagsdkLockParams
{
	DWORD	Mode;
	DWORD	Reserved;							// 
}sdkLockParams;
//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkLockLine( DWORD dwChannelId, sdkLockParams LockParams);

// -----       ----
//    
typedef struct tagsdkGainParams
{
	DWORD	Gain;								//   
	DWORD	Reserved;							// 
}sdkGainParams;
//       
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetGainMode( DWORD dwChannelId, sdkGainParams GainParams);
//       
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetGainMode( DWORD dwChannelId, sdkGainParams *lpGainParams);

// -----      ----
//     
typedef struct tagsdkGainModeParams
{
	DWORD	Gain;								//   
	DWORD	Reserved;							// 
} sdkGainModeParams;
//       
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetGainModeParams( DWORD dwChannelId, sdkGainModeParams GainModeParams);
//       
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetGainModeParams( DWORD dwChannelId, sdkGainModeParams *lpGainModeParams);

// -----     ----
// -----     ----
//   
typedef struct tagsdkAgcParams
{
	DWORD	Dynamic;							//    
	DWORD	Time;								//    
	DWORD	NoiseLevel;							//  
	DWORD	Mode;								//  
}sdkAgcParams;
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetAGCRecordMode( DWORD dwChannelId, sdkAgcParams AgcRecParams);
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetAGCRecordMode( DWORD dwChannelId, sdkAgcParams *lpAgcRecParams);
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetAGCPlayMode( DWORD dwChannelId, sdkAgcParams AgcPlayParams);
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetAGCPlayMode( DWORD dwChannelId, sdkAgcParams *lpAgcPlayParams);

// -----  VOX ----
//   VOX
typedef struct tagsdkVoxParams
{
	DWORD	Mode;
	DWORD	Level;
	DWORD	Time;
}sdkVoxParams;
//    VOX
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetVoxMode( DWORD dwChannelId, sdkVoxParams VoxParams);
//    VOX
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetVoxMode( DWORD dwChannelId, sdkVoxParams *lpVoxParams);

// -----  / ----- 
//   
typedef struct tagsdkAccuParams
{
	DWORD	Mode;
	DWORD	Level;
	DWORD	Time;
}sdkAccuParams;
//   / 
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetAccuParams( DWORD dwChannelId, sdkAccuParams AccuParams);
//   / 
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetAccuParams( DWORD dwChannelId, sdkAccuParams *lpAccuParams);

// -----      ----- 
//     
typedef struct tagsdkLevelIndicationParams
{
	DWORD	Mode;
	DWORD	Reserved;							// 
}sdkLevelIndicationParams;
//       
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetLevelMode( DWORD dwChannelId, sdkLevelIndicationParams LevelIndicationParams);
//       
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetLevelMode( DWORD dwChannelId, sdkLevelIndicationParams *lpLevelIndicationParams);

// -----       ----- 
//      
typedef struct tagsdkLevelExIndicationParams
{
	DWORD	Mode;
	DWORD	Reserved;							// 
}sdkLevelExIndicationParams;
//        
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetLevelModeEx( DWORD dwChannelId, sdkLevelExIndicationParams LevelIndicationParams);
//        
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetLevelModeEx( DWORD dwChannelId, sdkLevelExIndicationParams *lpLevelIndicationParams);

// -----      ----
//    
typedef struct tagsdkRecordParams
{
	DWORD	Mode;
	DWORD	Reserved;							// 
}sdkRecordParams;
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetRecordMode( DWORD dwChannelId, sdkRecordParams RecordParams);
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetRecordMode( DWORD dwChannelId, sdkRecordParams *lpRecordParams);

// ----      ----
//   
typedef struct tagsdkVolumeParams
{
	DWORD	Volume;
	DWORD	Reserved;							// 
}sdkVolumeParams;
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetVolume( DWORD dwChannelId, sdkVolumeParams VolumeParams);
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetVolume( DWORD dwChannelId, sdkVolumeParams *lpVolumeParams);

// ----    ----
#define sdkExPlayOrdinary					0
#define sdkExPlayUniform					1
#define sdkExPlayUniformPauseToNoise		2
//    
typedef struct tagsdkPlayModeExParams
{
	DWORD	Mode;
	DWORD	BufSize;
}sdkPlayModeExParams;
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetPlayModeEx( DWORD dwChannelId, sdkPlayModeExParams PlayModeExParams);
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetPlayModeEx( DWORD dwChannelId, sdkPlayModeExParams *lpPlayModeExParams);

// ----        ----
//      
typedef struct tagsdkNoiseVolumeParams
{
	DWORD	NoiseVolume;						//  
	DWORD	Reserved;							// 
}sdkNoiseVolumeParams;
//         
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetNoiseVolume( DWORD dwChannelId, sdkNoiseVolumeParams NoiseVolumeParams);
//         
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetNoiseVolume(DWORD ChannelId, sdkNoiseVolumeParams *lpNoiseVolumeParams);

//      
typedef struct tagsdkNoiseBlocksParams
{
	DWORD	Amount;
	DWORD	Volume;
} sdkNoiseBlocksParams;
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkPlayNoiseBlock( DWORD dwChannelId, sdkNoiseBlocksParams dwNoiseBlocksParams);

//   
typedef struct tagsdkGetVoiceParams
{
	void	*VoicePtr;							//      
	DWORD	Lenght;								//  
	DWORD	*Readed;							//  							
}sdkGetVoiceParams;
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetVoiceData( DWORD dwChannelId, sdkGetVoiceParams GetVoiceParams);

//   
typedef struct tagsdkPutVoiceParams
{
	DWORD	PlayMode;							// 
	void	*VoicePtr;							//      
	DWORD	Lenght;								//  
}sdkPutVoiceParams;
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkPlayVoiceData( DWORD dwChannelId, sdkPutVoiceParams PutVoiceParams);

// ----       ----
//       
typedef struct tagsdkFlashParams
{
	DWORD	FlashTime;		//	 
	DWORD	Reserved;
}sdkFlashParams;
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetFlash( DWORD dwChannelId, sdkFlashParams FlashParams);

//    
typedef struct tagsdkCommunicateParams
{
	DWORD SrcChannelId;
	DWORD DstChannelId;
	DWORD Mode;
	DWORD Volume;			//  0,         
							//    0,  
	DWORD Type;				// 0-, 1-
}sdkCommunicateParams;
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetCommunicate( sdkCommunicateParams CommunicateParams);

//       Scbus
typedef struct tagsdkCommunicateParamsEx
{
	DWORD SrcChannelId;
	DWORD DstChannelId;
	DWORD Mode;
	DWORD Volume;								//  (   -9, -10)
}sdkCommunicateParamsEx;
//        Scbus
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetCommunicateEx( sdkCommunicateParamsEx CommunicateParamsEx);

//      
typedef struct tagsdkConferenceParams
{
	DWORD Mode;									// 
	DWORD ConfId;								//  
	DWORD Reserved;								// 
}sdkConferenceParams;
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetConference( DWORD dwChannelId, sdkConferenceParams ConferenceParams);

// -----  DTMF -----
//       DTMF
typedef struct tagsdkDTMFFilteringParams
{
	DWORD Mode;									// 
	DWORD Reserved;								// 
}sdkDTMFFilteringParams;
//    DTMF
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetDTMFFiltering( DWORD dwChannelId, sdkDTMFFilteringParams DTMFFilteringParams);
//    DTMF
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetDTMFFiltering( DWORD dwChannelId, sdkDTMFFilteringParams *lpDTMFFilteringParams);

// -----  -----
//      
typedef struct tagsdkNoiseCancelerParams
{
	DWORD NoiseLevel;		//  
	DWORD TimeConstant;		// 
	DWORD Reserved;			// 
}sdkNoiseCancelerParams;
//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetNoiseCanceler( DWORD dwChannelId, sdkNoiseCancelerParams NoiseCancelerParams);
//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetNoiseCanceler( DWORD dwChannelId, sdkNoiseCancelerParams *lpNoiseCancelerParams);

// ----      ----
//    FXO  "-9"
//       
typedef struct tagsdkPolarityReversalParams
{
	DWORD Mode;			
	DWORD Reserved;			// 
}sdkPolarityReversalParams;	
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetPolarityReversal( DWORD dwChannelId, sdkPolarityReversalParams PolarityReversalParams);
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetPolarityReversal( DWORD dwChannelId, sdkPolarityReversalParams *lpPolarityReversalParams);

// -----   DTMF  ----- 
//    DTMF  
typedef struct tagsdkDTMFDetectorParams
{
	DWORD Sensibility;		//    *12
	DWORD Reserved;			// 
}sdkDTMFDetectorParams;	
//   DTMF  
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetDTMFDetectorSensibility( DWORD dwChannelId, sdkDTMFDetectorParams DTMFDetectorParams);
//   DTMF  
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetDTMFDetectorSensibility( DWORD dwChannelId, sdkDTMFDetectorParams *lpDTMFDetectorParams);

// -----   DTMF  ----- 
//    DTMF  
typedef struct tagsdkDTMFDetectorModeParams
{
	DWORD Mode;				//   
	DWORD Reserved;			// 
}sdkDTMFDetectorModeParams;	
//    DTMF  
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetDTMFDetectorMode( DWORD dwChannelId, sdkDTMFDetectorModeParams DTMFDetectorModeParams);
//    DTMF  
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetDTMFDetectorMode( DWORD dwChannelId, sdkDTMFDetectorModeParams *lpDTMFDetectorModeParams);

// -----     ----- 
//       
typedef struct tagsdkToneLevelParams
{
	DWORD Level;			//    *15	
	DWORD Reserved;			// 
}sdkToneLevelParams;	
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetToneLevel( DWORD dwChannelId, sdkToneLevelParams ToneLevelParams);
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetToneLevel( DWORD dwChannelId, sdkToneLevelParams *lpToneLevelParams);

// -----     ----- 
//     ,   
typedef struct tagsdkPBXToneLevelParams
{
	DWORD Level;			//    *15	
	DWORD Reserved;			// 
}sdkPBXToneLevelParams;	
//    ,    
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetPBXToneLevel( DWORD dwChannelId, sdkPBXToneLevelParams PBXToneLevelParams);
//    ,    
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetPBXToneLevel( DWORD dwChannelId, sdkPBXToneLevelParams *lpPBXToneLevelParams);

// -----   DTMF- ----- 
//      DTMF- 
typedef struct tagsdkDTMFDialLevelParams
{
	DWORD Level;			//   DTMF- *15	
	DWORD Reserved;			// 
}sdkDTMFDialLevelParams;	
//     DTMF- 
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetDTMFDialLevel( DWORD dwChannelId, sdkDTMFDialLevelParams DTMFDialLevelParams);
//     DTMF- 
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetDTMFDialLevel( DWORD dwChannelId, sdkDTMFDialLevelParams *lpDTMFDialLevelParams);

// -----       ----- 
//    FXO  "-9"
//       
typedef struct tagsdkLineBreakParams 
{
	DWORD DetectionMode;	//    *0 
	DWORD DetectionLevel;	//      *3
	DWORD Reserved;			// 
}sdkLineBreakParams;	
//       
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetLineBreakParams( DWORD dwChannelId, sdkLineBreakParams LineBreakParams);
//       
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetLineBreakParams( DWORD ChannelId, sdkLineBreakParams *lpLineBreakParams);

//    FXS (  -14)
typedef struct _tag_sdkFXSParams
{
	DWORD dwHookUpDetectTime;		//     (150-5000 , 250   .,  10 )
	DWORD dwHookDownDetectTime;		//     (150-5000 , 500   .,  10 )
	DWORD dwFlashDetectTime;		//   FLASH (60-1000 , 100   .,  10 )
	DWORD dwPulseDurDetectTime;		//   . (20-250 , 50   .,  10 )
	DWORD dwPulsePauseDetectTime;	//   . (20-250 , 30   .,  10 )
	int iRxGainLevel;				//       (-12dB..3dB, -7 dB  .,  1 dB)
	int iTxGainLevel;				//       (-15dB..0dB, -1 dB  .,  1 dB)
	DWORD dwPowerLevel;				// 0 -   ( ), >0 -   ( )
	DWORD dwDTMFToneDuration;		//   DTMF( 40 - 0xFFFF , 80  -  )
	DWORD dwDTMFPauseDuration;		//     DTMF( 30 - 0xFFFF , 250  -  )
	DWORD dwReserved[28];			//   ,  
} sdkFXSParams;
//   FXS   -14
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetFXSParams( DWORD dwChannelId, sdkFXSParams FXSParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetFXSParams( DWORD dwChannelId, sdkFXSParams *lpFXSParams);

//    FXO (  -14)
typedef struct _tag_sdkFXOParams
{
	DWORD dwHookUpTimeForOutgoing;	//      . (150-5000 , 250   .,  10 )
	DWORD dwHookUpTimeForIncoming;	//      . (150-5000 , 500   .,  10 )
	DWORD dwHookDownTime;			//     (150-5000 , 800   .,  10 )
	DWORD dwPulseDurTime;			//   . (20-250 , 60   .,  10 )
	DWORD dwPulsePauseTime;			//   . (20-250 , 40   .,  10 )
	int iRxGainLevel;				//       (-12dB..3dB, -7 dB  .,  1 dB)
	int iTxGainLevel;				//       (-15dB-0dB, -1 dB  .,  1 dB)
	DWORD dwDTMFToneDuration;		//   DTMF( 40 - 0xFFFF , 80  -  )
	DWORD dwDTMFPauseDuration;		//     DTMF( 30 - 0xFFFF , 250  -  )
	DWORD dwReserved[29];			//   ,  
} sdkFXOParams;
//   FXO   -14
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetFXOParams( DWORD dwChannelId, sdkFXOParams FXOParams);
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetFXOParams( DWORD dwChannelId, sdkFXOParams *lpFXOParams);

// ======================================================================
// ====================    ==================
// ======================================================================
typedef struct tagsdkExtE1StatusParams
{
	HANDLE hSignalEvent;								// 	event 		
	void (*lpExtHandler)( sdkE1Status *lpE1Status);		//  
}sdkExtE1StatusParams;
//  Event (CALLBACK)   E1
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1StatusEvent( DWORD dwBoardId, sdkExtE1StatusParams ExtE1StatusParams);
//  Event (CALLBACK)   E1
SDKIMPORT_ SDKEXPORT_ DWORD sdkResetE1StatusEvent( DWORD dwBoardId);

typedef struct tagsdkExtE1StatusParamsEx
{
	DWORD dwUserThreadID;								//   
	UINT dwUserMess;									// 
}sdkExtE1StatusParamsEx;
//  Event (CALLBACK)   E1
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetE1StatusEventEx( DWORD dwBoardId, sdkExtE1StatusParamsEx ExtE1StatusParamsEx);
//  Event (CALLBACK)   E1
SDKIMPORT_ SDKEXPORT_ DWORD sdkResetE1StatusEventEx( DWORD dwBoardId);

typedef struct tagsdkExtUSBStatusParams 
{
	HANDLE SignalEvent;													// 	event 		
	void (*ExtHandler)( DWORD BoardsCount, void *lpBoardStatusData);	//  
}sdkExtUSBStatusParams;
//  Event (CALLBACK)   / USB- "-12"
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetUSBSBoardStatusEvent( DWORD dwDriverId, sdkExtUSBStatusParams ExtUSBStatusParams);
//  Event (CALLBACK)   / USB- "-12"
SDKIMPORT_ SDKEXPORT_ DWORD sdkResetUSBSBoardStatusEvent( DWORD dwDriverId);

//  -
#define SDK_WAIT_INFINIT			-1
//    
typedef struct tagsdkExtHandlerStatus
{
	DWORD ChannelId;				//  
	sdkLineStatus LastLineStatus;	//    
	DWORD SignalFlag;				//  
	DWORD WaitFlag;					//  
	DWORD ConnectFlag;				//  
	DWORD IoFlag;					//  -
	DWORD LastExtError;				//    

	DWORD Reserved1;				// 
	DWORD Reserved2;				// 
} sdkExtHandlerStatus;

//     
typedef struct tagsdkExtSignalParams
{
	HANDLE SignalEvent;											// 	event 		
	void (*ExtHandler)( sdkExtHandlerStatus *lpExtHandlerStatus); //  
	DWORD SignalEventType;										//   
	UINT SignalEventCount;										//   
	UINT WaitTimeOut;											// -
} sdkExtSignalParams;

//     
typedef struct tagsdkExtSignalParamsEx
{
	DWORD ThreadID;
	UINT  Message;
	DWORD SignalEventType;										//   
	UINT SignalEventCount;										//   
	UINT WaitTimeOut;											// -
}sdkExtSignalParamsEx;
//  Event (CALLBACK) 
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetSignalEvent(	DWORD dwChannelId, sdkExtSignalParams ExtSignalParams);
//  Event 
SDKIMPORT_ SDKEXPORT_ DWORD sdkResetSignalEvent( DWORD dwChannelId,	sdkExtSignalParams ExtSignalParams);
//  Message 
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetSignalEventEx( DWORD dwChannelId, sdkExtSignalParamsEx ExtSignalParamsEx);
//  Message 
SDKIMPORT_ SDKEXPORT_ DWORD sdkResetSignalEventEx (	DWORD dwChannelId, sdkExtSignalParamsEx ExtSignalParamsEx);
//  Event (CALLBACK)   n-  
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetWaitForNSignalEvent (	DWORD dwChannelId, sdkExtSignalParams ExtSignalParams);
//  Event (CALLBACK)   n-  
SDKIMPORT_ SDKEXPORT_ DWORD sdkResetWaitForNSignalEvent( DWORD dwChannelId);


// ----    ----
//     
typedef struct tagsdkExtConnectParams
{
	HANDLE	ConnectEvent;										// 	event 		
	void (*ExtHandler)( sdkExtHandlerStatus *ExtHandlerStatus); //  
	sdkDialParams	DialParams;									//  					
	UINT	ConnectTimeOut;										// -
	BOOL	WaitVad;											//  VAD
	BOOL 	AutoDial;											// 
}sdkExtConnectParams;
//  ,  DialTone,  event (CALLBACK)
SDKIMPORT_ SDKEXPORT_ DWORD sdkConnect(	DWORD dwChannelId, sdkExtConnectParams ExtConnectParams);
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkCancelConnect( DWORD dwChannelId);

// ----    ----
//     
//       
typedef struct tagsdkExtPlayParams
{
	HANDLE	PlayEvent;											// 	event 		
	void (*ExtHandler)( sdkExtHandlerStatus *ExtHandlerStatus); //  
	DWORD PlayDeltaBuf;											//  -
}sdkExtPlayParams;
//  Event (CALBACK) 
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetPlayEvent( DWORD dwChannelId, sdkExtPlayParams ExtPlayParams);
//  Event (CALBACK) 
SDKIMPORT_ SDKEXPORT_ DWORD sdkResetPlayEvent( DWORD dwChannelId);

//      
typedef struct tagsdkExtPlayBlockParams
{
	HANDLE	PlayEvent;											// 	event 		
	void (*ExtHandler)( sdkExtHandlerStatus *ExtHandlerStatus); //  
	DWORD PlayDeltaBuf;											//  -
	DWORD Compression;											// 
	void	*VoicePtr;											//      
	DWORD	Lenght;												//  
}sdkExtPlayBlockParams;
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkPlayBufByPlayEvent( DWORD dwChannelId, sdkExtPlayBlockParams ExtPlayBlockParams);

//      
typedef struct tagsdkExtPlayFileParams
{
	HANDLE	PlayStarted;										// 	event  		
	HANDLE	PlayStoped;											// 	event  		
	void (*ExtHandler)( sdkExtHandlerStatus *ExtHandlerStatus); //  
	DWORD	StartSignalEventType;								//      		
	DWORD	StopSignalEventType;								//      		
	char	*FileName;											//   
}sdkExtPlayFileParams;
//    WAV-
SDKIMPORT_ SDKEXPORT_ DWORD sdkStartPlayFromWav( DWORD dwChannelId,	sdkExtPlayFileParams ExtPlayFileParams);
//    WAV-
SDKIMPORT_ SDKEXPORT_ DWORD sdkStopPlayFromWav( DWORD dwChannelId);

//       
typedef struct tagsdkExtPlayFilesParams
{
	HANDLE	PlayStarted;										// 	event  		
	HANDLE	PlayStoped;											// 	event  		
	void (*ExtHandler)( sdkExtHandlerStatus *ExtHandlerStatus); //  
	DWORD StartSignalEventType;								//      		
	DWORD StopSignalEventType;								//      		
	char *FileName;											//   
	char *FileDir;											//   
}sdkExtPlayFilesParams;
//     ,   sdkStartPlayFromWav     
//     WAV-
SDKIMPORT_ SDKEXPORT_ DWORD sdkStartPlayFromWaves( DWORD dwChannelId, sdkExtPlayFilesParams ExtPlayFilesParams);

//     
//      
typedef struct tagsdkExtRecParams
{
	HANDLE	RecEvent;												// 	event 		
	void (*ExtHandler)( sdkExtHandlerStatus *lpExtHandlerStatus); //  
	DWORD RecDeltaBuf;												//  -
}sdkExtRecParams;
//  Event (CALBACK) 
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetRecEvent(	DWORD dwChannelId, sdkExtRecParams ExtRecParams);
//  Event (CALBACK) 
SDKIMPORT_ SDKEXPORT_ DWORD sdkResetRecEvent( DWORD dwChannelId);

//      
typedef struct tagsdkExtRecBlockParams
{
	HANDLE	RecEvent;											// 	event 		
	void (*ExtHandler)( sdkExtHandlerStatus *ExtHandlerStatus); //  
	DWORD RecDeltaBuf;											//  -
	void	*VoicePtr;											//      
	DWORD	Lenght;												//  
}sdkExtRecBlockParams;
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkRecBufByRecEvent( DWORD dwChannelId,	sdkExtRecBlockParams ExtRecBlockParams);

//      
typedef struct tagsdkExtRecFileParams
{
	HANDLE	RecStarted;											// 	event  
	HANDLE	RecStoped;											// 	event  
	void (*ExtHandler)( sdkExtHandlerStatus *ExtHandlerStatus); //  
	DWORD	StartSignalEventType;								//      
	DWORD	StopSignalEventType;								//      
	char	*FileName;											//   
}sdkExtRecFileParams;
//    WAV-
SDKIMPORT_ SDKEXPORT_ DWORD sdkStartRecToWav( DWORD dwChannelId, sdkExtRecFileParams ExtRecFileParams);
//    WAV-
SDKIMPORT_ SDKEXPORT_ DWORD sdkStopRecToWav( DWORD dwChannelId);

//    
typedef struct tagsdkSysTime
{ 
    WORD Year; 
    WORD Month; 
    WORD DayOfWeek; 
    WORD Day; 
    WORD Hour; 
    WORD Minute; 
    WORD Second; 
    WORD Milliseconds; 
} sdkSysTime; 

//   
typedef struct tagsdkSeanceStatus
{
	CHAR	ToneNumbers[128];
	CHAR	PulseNumbers[128];
	CHAR	AonNumbers[32];
	DWORD	Incomming;
	tagsdkSysTime	SeanceStartTime;
	tagsdkSysTime	SeanceStopTime;
	DWORD	SeanceTime;
}sdkSeanceStatus;
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetLastSeanceInfo( DWORD dwChannelId, sdkSeanceStatus *SeanceStatus);


//   () 
#define ON_ALL_EVENTS				0xFFFFFFFF		//  
#define ON_RING_ON					0x00000001		//  
#define ON_RING_OFF					0x00000002		//  
#define ON_LEVEL_CHANGED			0x00000004		//  
#define ON_HOOK_UP					0x00000008		//  
#define ON_HOOK_DOWN				0x00000010		//  
#define ON_DIAL_TONE_NUMBER			0x00000020		//     
#define ON_DIAL_PULSE_NUMBER		0x00000040		//     
#define ON_VOX_ON					0x00000080		// VOX
#define ON_VOX_OFF					0x00000100		// VOX
#define ON_INCOMMING				0x00000200		//  - 
#define ON_OUTGOING					0x00000400		//  - 
#define ON_LINE_BREAK				0x00000800		//   
#define ON_DIAL_TONE				0x00001000		//    ""
#define ON_BACK_RING				0x00002000		//    ""
#define ON_BUSY						0x00004000		//    ""
#define ON_AON_DETECT				0x00008000		//   
#define ON_AON_FAILED				0x00010000		//   
#define ON_NUMBER_DIALED			0x00020000		//  
#define ON_PULSE_NUMBER_DIALED		0x00020000		//     
#define ON_TONE_NUMBER_DIALED		0x00040000		//     
#define ON_VAD						0x00080000		//   
#define ON_ACU_START				0x00100000		// 
#define ON_ACU_STOP					0x00200000		// 
#define ON_FLASH					0x00200000		// 
#define ON_FAX_ON					0x00400000		//   
#define ON_FAX_OFF					0x00800000		//    
#define ON_START_PLAY				0x01000000		//    
#define ON_END_PLAY					0x02000000		//    
#define ON_E1_TSREADY				0x04000000		//  1  TSReady
#define ON_E1_CONNECT				0x08000000		//   1 ;
#define ON_E1_DISCONNECT			0x10000000		//   1   DISCONNECT;
#define ON_E1_RELEASE				0x20000000		//   1   RELEASE;
#define ON_SIGNAL_ERROR				0x80000000		// 

//   n- 
#define ON_WAIT_COMPLELTE			0x00000001		// n-  
#define ON_WAIT_FAILED				0x00000002		// n-   

//  
#define ON_CONNECT_COMPLELTE		0x00000001		//  
#define ON_CONNECT_FAILED			0x00000002		//   

//     - 
#define ON_PLAY_DELTABUF			0x00000001		//   -  
#define ON_RECORD_DELTABUF			0x00000002		//   -  

//   - 
#define ON_PLAY_STARTED				0x00000001		//  
#define ON_PLAY_STOPED				0x00000002		//  
#define ON_RECORD_STARTED			0x00000004		//  
#define ON_RECORD_STOPED			0x00000008		//  

// ======================================================================
// ===================     ===================
// ======================================================================
//   
typedef struct tagsdkFaxStatus
{
	DWORD RecProcessStatus;				//     
	DWORD SendProcessStatus;			//     
	DWORD RecFinalStatus;				//     
	DWORD SendFinalStatus;				//     
	DWORD Error;						// 
	DWORD SendParam;					//  
}sdkFaxStatus;

//     RecProcessStatus
#define sdkFaxReceiveOff					0
#define sdkFaxReceiveSendDIS				1
#define sdkFaxReceiveWaitDCS				2
#define sdkFaxReceiveTren2400				3
#define sdkFaxReceiveTren4800				4
#define sdkFaxReceiveTren7200				5
#define sdkFaxReceiveTren9600				6
#define sdkFaxReceive2400					7
#define sdkFaxReceive4800					8
#define sdkFaxReceive7200					9
#define sdkFaxReceive9600					10
#define sdkFaxReceiveWaitPMC				11
#define sdkFaxReceiveSendPIN				12
#define sdkFaxReceiveSendMCF				13
#define sdkFaxReceiveSendFTT				14
#define sdkFaxReceiveSendCFR				15
#define sdkFaxReceiveSendCRP				16
#define sdkFaxReceiveDevErrFax				98
#define sdkFaxReceiveSysErrFax				99
//     SendProcessStatus
#define sdkFaxTransmitOff					0
#define sdkFaxTransmitConnecting			1
#define sdkFaxTransmitTraining				2
#define sdkFaxTransmitSending				3

//     RecFinalStatus
#define sdkFaxReceiveNoError				0x0000
#define sdkFaxReceiveSystemError			0xFF01
#define sdkFaxReceiveDriverError			0xFF02
#define sdkFaxReceiveDeviceIoError			0xFF03
#define sdkFaxReceiveMemoryFault			0xFF04
#define sdkFaxReceiveAlreadyStarted			0xFF05
#define sdkFaxReceiveFileWriteError			0xFF08
#define sdkFaxReceiveNoFaxPages				0xFF09
#define sdkFaxReceiveTooManyLines			0xFF0A
#define sdkFaxReceiveVersionFault			0xFF0B
#define sdkFaxReceiveDriverVersionFault		0xFF0C
#define sdkFaxReceiveFileCorrupt			0xFF0D
#define sdkFaxReceiveMustBeRun				0xFF0E
#define sdkFaxReceiveUncorrectVersion		0xFF0F
//      SendFinalStatus
#define sdkFaxTransmitNoError				0x0000
#define sdkFaxTransmitSystemError			0xFF01
#define sdkFaxTransmitDriverError			0xFF02
#define sdkFaxTransmitDeviceIoError			0xFF03
#define sdkFaxTransmitMemoryFault			0xFF04
#define sdkFaxTransmitAlreadyStarted		0xFF05
#define sdkFaxTransmitFileReadError			0xFF08
#define sdkFaxTransmitNoFaxPages			0xFF09
#define sdkFaxTransmitTooManyLines			0xFF0A
#define sdkFaxTransmitVersionFault			0xFF0B
#define sdkFaxTransmitDriverVersionFault	0xFF0C
#define sdkFaxTransmitFileCorrupt           0xFF0D
#define sdkFaxTransmitMustBeRun				0xFF0E
#define sdkFaxTransmitUncorrectVersion		0xFF0F

//     DebugInfo   9,10,
SDKIMPORT_ SDKEXPORT_ DWORD sdkMakeAlder9BoardDebugLog( DWORD dwBoardId);



// ======================================================================
// ==============    =================
// ======================================================================
//    
// DriverId								-	 
// Irq									-	
//  				-	 
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetIrq( DWORD dwDriverId, DWORD *Irq);

//    
// DriverId								-	 
// Irq									-	
//  				-	 
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetIrq( DWORD dwDriverId, DWORD Irq);

//     
// DriverId								-	 
// IrqFreq								-	 
//  				-	 
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetIrqFreq( DWORD dwDriverId, DWORD *dwIrqFreq);

//     
// DriverId								-	 
// IrqFreq								-	 
//  				-	 
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetIrqFreq( DWORD dwDriverId, DWORD dwIrqFreq);

typedef struct _tag_sdkBoardProperties
{
	char pszLoader[256];
	DWORD dwNeedSCBus;
	DWORD SCBusTerminator;
	DWORD lpdwReserved[254];
} sdkBoardProperties;
SDKIMPORT_ SDKEXPORT_ DWORD sdkSetBoardProperties( DWORD dwBoardID, sdkBoardProperties BoardProperties);

//       
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetLastBoardError( DWORD dwBoardId);

// ======================================================================
// ==============      =============
// ======================================================================
//  
SDKIMPORT_ SDKEXPORT_ DWORD sdkReserveChannel( DWORD dwChannelId);
//  
SDKIMPORT_ SDKEXPORT_ DWORD sdkFreeChannel( DWORD dwChannelId);
//  
SDKIMPORT_ SDKEXPORT_ DWORD sdkOpenChannel( DWORD dwChannelId);
//  
SDKIMPORT_ SDKEXPORT_ DWORD sdkCloseChannel( DWORD dwChannelId);
//       
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetLastChannelError( DWORD dwChannelId);

// -----    - ----
SDKIMPORT_ SDKEXPORT_ DWORD sdkDefaultChannelParams( DWORD dwChannelId);
//      
SDKIMPORT_ SDKEXPORT_ DWORD sdkGetLastExtError( DWORD dwChannelId);

// ======================================================================
// =======================     ======================
// ======================================================================
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkFaxInit( char *pszFaxKey, DWORD *lpdwMajorVersion, DWORD *lpdwMinorVersion);
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkFaxLeave();
//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkFaxSend( DWORD dwChannelId, char *pszFaxFileName);
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkFaxCancelSend( DWORD dwChannelId);
//   
SDKIMPORT_ SDKEXPORT_ DWORD sdkFaxReceive( DWORD dwChannelId, char *pszFaxFileName);
//    
SDKIMPORT_ SDKEXPORT_ DWORD sdkFaxCancelReceive( DWORD dwChannelId);
//     
SDKIMPORT_ SDKEXPORT_ DWORD sdkFaxGetStatus( DWORD dwChannelId, sdkFaxStatus *lpFaxStatus);
//  bmp  
SDKIMPORT_ SDKEXPORT_ DWORD sdkBmp2Fax( char *pszDestFile, char *pszSrcFile);
//    bmp
SDKIMPORT_ SDKEXPORT_ DWORD sdkFax2Bmp( char *pszDestFile, char *pszSrcFile);

// ***********************************************************
// *********************       *********************   
// ***********************************************************
#define SDK_ERROR_BASE						0xA000
#define SDK_NOERROR							0x0000

// =========       ===========
#define SDK_ALREADY_INIT					SDK_ERROR_BASE + 0x0001		//   
#define SDK_ALREADY_LEAVE					SDK_ERROR_BASE + 0x0002		//   
#define SDK_ALDERDRV_DRIVER_NOT_FOUND		SDK_ERROR_BASE + 0x0003		// AlderDrv -   
#define SDK_ALDERDRV_DRIVER_NOT_LOADED		SDK_ERROR_BASE + 0x0004		// AlderDrv -   
#define SDK_ALDERDRV9_DRIVER_NOT_FOUND		SDK_ERROR_BASE + 0x0005		// Alder9Drv -   
#define SDK_ALDERDRV9_DRIVER_NOT_LOADED		SDK_ERROR_BASE + 0x0006		// Alder9Drv -   
#define SDK_ALDERDRV12_DRIVER_NOT_FOUND		SDK_ERROR_BASE + 0x0007		// Alder9Drv -   
#define SDK_ALDERDRV12_DRIVER_NOT_LOADED	SDK_ERROR_BASE + 0x0008		// Alder9Drv -   
#define SDK_NO_ONE_DRIVER_LOADED			SDK_ERROR_BASE + 0x0009		//     		
#define SDK_INCORRECT_DRIVER_VERSION		SDK_ERROR_BASE + 0x000A		//    ( AlderDrv < 4.65)		
#define SDK_BOARDS_ALREADY_STARTED			SDK_ERROR_BASE + 0x000B		//     
#define SDK_BOARDS_ALREADY_STOPED			SDK_ERROR_BASE + 0x000C		//     
#define SDK_BOARD_ALREADY_OPENED			SDK_ERROR_BASE + 0x000D		//     
#define SDK_BOARD_ALREADY_CLOSED			SDK_ERROR_BASE + 0x000E		//   
#define SDK_BOARD_LOADER_INVALID			SDK_ERROR_BASE + 0x000F		//   
#define SDK_MEMORY_ERROR					SDK_ERROR_BASE + 0x0010		//     
#define SDK_PROCESSING_ERROR				SDK_ERROR_BASE + 0x0011		//      
#define SDK_INVALID_IN_PARAMETER			SDK_ERROR_BASE + 0x0012		//   
#define SDK_NOT_SUPPORTED					SDK_ERROR_BASE + 0x0013		//       AlderSDK
#define SDK_ALDERDRV14T_DRIVER_NOT_LOADED	SDK_ERROR_BASE + 0x0014		// Alder14tDrv -   
#define SDK_ALDERDRV_THREAD_NOT_ANSWER		SDK_ERROR_BASE + 0x0015		// Alder14tDrv -   -  

// =======         ========
#define SDK_WRONG_OPERATION_FOR_BOARD_TYPE  SDK_ERROR_BASE + 0x0201		//      
#define SDK_WRONG_ASKED_BOARDS_COUNT		SDK_ERROR_BASE + 0x0203		//    
#define SDK_WRONG_ASKED_DRIVERS_COUNT		SDK_ERROR_BASE + 0x0204		//    
#define SDK_CHANNEL_BUSY					SDK_ERROR_BASE + 0x0205		//  
#define SDK_CHANNEL_NOT_OPENED				SDK_ERROR_BASE + 0x0206		//   
#define SDK_CHANNEL_NOT_RESERVED			SDK_ERROR_BASE + 0x0207		//   

// =======       ========
#define SDK_DEVICE_IO_ERROR					SDK_ERROR_BASE + 0x0301		//    WINAPI DeviceIoControl
#define SDK_INVALID_METHOD					SDK_ERROR_BASE + 0x0302		//     ,  
#define SDK_NO_BOARD_IRQ					SDK_ERROR_BASE + 0x0303		//    

// =======     ========
#define SDK_EXTENDED_METHOD_ALREADY_RUNNING SDK_ERROR_BASE + 0x0401		//     
#define SDK_EXTENDED_METHOD_ALREADY_STOPED	SDK_ERROR_BASE + 0x0402		//     
#define SDK_WRONG_SIGNAL_EXTENEDED_FLAG		SDK_ERROR_BASE + 0x0403		//   
#define SDK_EXTENDED_METHOD_LEAVE_TIMEOUT	SDK_ERROR_BASE + 0x0404		//      -
#define SDK_EXTENDED_METHOD_MANUAL_TERMINATED SDK_ERROR_BASE + 0x0405	//     

// =======       ========
#define SDK_EXTENDED_WAVE_HDR_INVALID		SDK_ERROR_BASE + 0x0501		//       (  )
#define SDK_EXTENDED_WAVE_SPEED_INVALID		SDK_ERROR_BASE + 0x0502		//       ( )
#define SDK_EXTENDED_WAVE_COMPRESS_INVALID	SDK_ERROR_BASE + 0x0503		//       (  )

#define SDK_EXTENDED_CANT_CREATE_WAV		SDK_ERROR_BASE + 0x0504		//      
#define SDK_EXTENDED_CANT_OPEN_WAV			SDK_ERROR_BASE + 0x0505		//      

// =======       ========
#define SDK_GATE_ALREADY_CREATE				SDK_ERROR_BASE + 0x0601		//   
#define SDK_GATE_ALREADY_CLOSE				SDK_ERROR_BASE + 0x0602		//   
#define SDK_CANT_LOAD_WINSOCK				SDK_ERROR_BASE + 0x0603		//     WINSOCKET		
#define SDK_CANT_LOAD_GATEDLL				SDK_ERROR_BASE + 0x0604		//     GateDll		
#define SDK_CANT_CREATE_NEW_CONNECT			SDK_ERROR_BASE + 0x0605		//       GateDll		
#define SDK_MAXIMUM_CONNECTIONS_CREATED     SDK_ERROR_BASE + 0x0607		//     

// =======      -  ========
#define SDK_FAX_ALREADY_INIT				SDK_ERROR_BASE + 0x0701		// -  
#define SDK_FAX_ALREADY_LEAVE				SDK_ERROR_BASE + 0x0702		// -  
#define SDK_CANT_LOAD_FULLFAXDLL			SDK_ERROR_BASE + 0x0703		//     FullFax.dll
#define SDK_FAX_IN_CAHNNEL					SDK_ERROR_BASE + 0x0704		//       () 
#define SDK_FAX_NO_IN_CAHNNEL				SDK_ERROR_BASE + 0x0705		//      () 

#ifdef _X_TRACE_IT_
void _dPrintf( char *pszFormat, ...);
#define _XTRACE_	_dPrintf
#define _XTRACE1_	_dPrintf
#else
#define _XTRACE_
#define _XTRACE1_
#endif

#pragma pack()

#endif